<?php

/*************************************************************

 File: makeforward.php3
 Author: didi
 Revision: 2.0.0
 Date: 1999/05/18

 This script creates/deletes/changes the forward
 entry in the alias file (/etc/mail/aliases/users)
 
 php-mailsetting:
 Copyright 1999 Dietmar Rieder <adrieder@sbox.tu-graz.ac.at>
 
 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

 ***************************************************************/


/*
  Do not cache the output
 */
header("Expires: 0");
header("Pragma: no-cache");
header("Cache-Control: no-cache, must-revalidate");

/*
  Required config file & function library
 */
require("lib/mailsettings-php.lib");
require("config/config.php3");

$default->lang = $lang->select_lang();
require("lang/$default->lang/interface.lang");

ignore_user_abort;
error_reporting($default->error_level);

setlocale ("LC_TIME", "de");
$now    = strftime("%d.%m.%Y - %H:%M:%S");
$c_user = get_current_user();
$pid    = getmypid();
$inf    = "$now $c_user"."[$pid]:";

settype($new_addr, "string");
if ((isset($id))) { $auth_ok_file = "$default->auth_ok_file.$id"; }

switch ($action) {

 case "SHOW_INT":
   if (file_exists($auth_ok_file) && CheckLoginTime($auth_ok_file)) {
     touch($auth_ok_file);
     if ($fwd_addr != "NULL") {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->change_int");
       include("$default->include_dir/$default->footer");
     }
     else {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->new_int");
       include("$default->include_dir/$default->footer");
     }
   }
   else {
     include("$default->include_dir/$default->header");
     include("$default->include_dir/$default->login_timed_out");
     include("$default->include_dir/$default->footer");
   }
   break;


 case "RETRY":
   if (file_exists($auth_ok_file) && CheckLoginTime($auth_ok_file)) {
     touch($auth_ok_file);
     if (isset($fwd_addr)) {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->change_int");
       include("$default->include_dir/$default->footer");    
     }
     else {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->new_int");
       include("$default->include_dir/$default->footer");       
     }
   }
   else {
     include("$default->include_dir/$default->header");
     include("$default->include_dir/$default->login_timed_out");
     include("$default->include_dir/$default->footer");
   }
   break;
   
   
 case "CHANGE":
   if (file_exists($auth_ok_file) && CheckLoginTime($auth_ok_file)) {
     $new_addr = str_replace(" ", "", $new_addr);
     if (!(CheckNewAddr($username, $new_addr))) {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->invalid_addr");
       include("$default->include_dir/$default->footer");
     }
     else {
       if (!(ChangeForward($username, $new_addr, $local_copy))) {
         include("$default->include_dir/$default->header");
	 include("$default->include_dir/$default->error");
         include("$default->include_dir/$default->footer");
	 error_log("$inf unable change set the forward-entry of $username to $new_addr (localcopy=$local_copy) -- makeforward.php3\n", 3, $default->logfile);
       }
       else {
         include("$default->include_dir/$default->header");
	 include("$default->include_dir/$default->success");
         include("$default->include_dir/$default->footer");
	 unlink($auth_ok_file);
	 error_log("$inf $username changed the forward-entry to $new_addr (localcopy=$local_copy) -- makeforward.php3\n", 3, $default->logfile);
       }
     }
   }
   else {
     include("$default->include_dir/$default->header");
     include("$default->include_dir/$default->login_timed_out");
     include("$default->include_dir/$default->footer");
   }
   break;
     
 case "ADD":
   if (file_exists($auth_ok_file) && CheckLoginTime($auth_ok_file)) {
     $new_addr = str_replace(" ", "", $new_addr);
     if (!(CheckNewAddr($username, $new_addr))) {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->invalid_addr");
       include("$default->include_dir/$default->footer");
     }
     else {
       if (!(AddForward($username, $new_addr, $local_copy))) {
         include("$default->include_dir/$default->header");
	 include("$default->include_dir/$default->error");
         include("$default->include_dir/$default->footer");
         error_log("$inf unable to set the forward-entry of $username to $new_addr (localcopy=$local_copy) -- makeforward.php3\n", 3, $default->logfile);
       }
       else {
         include("$default->include_dir/$default->header");
	 include("$default->include_dir/$default->success");
         include("$default->include_dir/$default->footer");
	 unlink($auth_ok_file);
	 error_log("$inf $username set the forward-entry to $new_addr (localcopy=$local_copy) -- makeforward.php3\n", 3, $default->logfile);
       }
     }     
   }
   else {
     include("$default->include_dir/$default->header");
     include("$default->include_dir/$default->login_timed_out");
     include("$default->include_dir/$default->footer");
   }
   break;

 case "DELETE":

   if (file_exists($auth_ok_file) && CheckLoginTime($auth_ok_file)) {
     if (!(DeleteForward($username))) {
         include("$default->include_dir/$default->header");
	 include("$default->include_dir/$default->error");
         include("$default->include_dir/$default->footer");
         error_log("$inf unable to delete the forward-entry of $username -- makeforward.php3\n", 3, $default->logfile);
     }
     else {
       include("$default->include_dir/$default->header");
       include("$default->include_dir/$default->success");
       include("$default->include_dir/$default->footer");
       unlink($auth_ok_file);
       error_log("$inf $username deleted his forward-entry -- makeforward.php3\n", 3, $default->logfile);
     }
   }
   else {
     include("$default->include_dir/$default->header");
     include("$default->include_dir/$default->login_timed_out");
     include("$default->include_dir/$default->footer");
   }
   break;

 case "LOGOUT":
   logout($username);
   break;
}

?>
